import{S as Ts,i as Ds,s as Fs,e as n,k as p,w as $,t as q,M as Ks,c as o,d as e,m as f,a as l,x as v,h as S,b as i,G as a,g as r,y as _,L as Qs,q as w,o as k,B as g,v as Vs}from"../chunks/vendor-hf-doc-builder.js";import{I as us,C as V}from"../chunks/CodeBlock-hf-doc-builder.js";function Ws(Ss){let h,W,m,y,R,P,ds,J,$s,X,G,vs,Y,c,j,O,A,_s,T,ws,Z,M,ks,ss,x,es,U,gs,ts,N,as,u,b,D,z,ys,F,js,ns,L,os,B,bs,rs,C,ls,d,E,K,H,Es,Q,qs,is,I,ps;return P=new us({}),A=new us({}),x=new V({props:{code:"pip install safetensors",highlighted:'pip <span class="hljs-keyword">install</span> safetensors'}}),N=new V({props:{code:"conda install -c huggingface safetensors",highlighted:'conda <span class="hljs-keyword">install</span> -c huggingface safetensors'}}),z=new us({}),L=new V({props:{code:`from safetensors import safe_open

tensors = {}
with safe_open("model.safetensors", framework="pt", device=0) as f:
    for k in f.keys():
        tensors[k] = f.get_tensor(k)`,highlighted:`<span class="hljs-keyword">from</span> safetensors <span class="hljs-keyword">import</span> safe_open

tensors = {}
<span class="hljs-keyword">with</span> safe_open(<span class="hljs-string">&quot;model.safetensors&quot;</span>, framework=<span class="hljs-string">&quot;pt&quot;</span>, device=<span class="hljs-number">0</span>) <span class="hljs-keyword">as</span> f:
    <span class="hljs-keyword">for</span> k <span class="hljs-keyword">in</span> f.keys():
        tensors[k] = f.get_tensor(k)`}}),C=new V({props:{code:`from safetensors import safe_open

tensors = {}
with safe_open("model.safetensors", framework="pt", device=0) as f:
    tensor_slice = f.get_slice("embedding")
    vocab_size, hidden_dim = tensor_slice.get_shape()
    tensor = tensor_slice[:, :hidden_dim]`,highlighted:`<span class="hljs-keyword">from</span> safetensors <span class="hljs-keyword">import</span> safe_open

tensors = {}
<span class="hljs-keyword">with</span> safe_open(<span class="hljs-string">&quot;model.safetensors&quot;</span>, framework=<span class="hljs-string">&quot;pt&quot;</span>, device=<span class="hljs-number">0</span>) <span class="hljs-keyword">as</span> f:
    tensor_slice = f.get_slice(<span class="hljs-string">&quot;embedding&quot;</span>)
    vocab_size, hidden_dim = tensor_slice.get_shape()
    tensor = tensor_slice[:, :hidden_dim]`}}),H=new us({}),I=new V({props:{code:`import torch
from safetensors.torch import save_file

tensors = {
    "embedding": torch.zeros((2, 2)),
    "attention": torch.zeros((2, 3))
}
save_file(tensors, "model.safetensors")`,highlighted:`<span class="hljs-keyword">import</span> torch
<span class="hljs-keyword">from</span> safetensors.torch <span class="hljs-keyword">import</span> save_file

tensors = {
    <span class="hljs-string">&quot;embedding&quot;</span>: torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">2</span>)),
    <span class="hljs-string">&quot;attention&quot;</span>: torch.zeros((<span class="hljs-number">2</span>, <span class="hljs-number">3</span>))
}
save_file(tensors, <span class="hljs-string">&quot;model.safetensors&quot;</span>)`}}),{c(){h=n("meta"),W=p(),m=n("h1"),y=n("a"),R=n("span"),$(P.$$.fragment),ds=p(),J=n("span"),$s=q("Safetensors"),X=p(),G=n("p"),vs=q("Safetensors is a new simple format for storing tensors safely (as opposed to pickle) and that is still fast (zero-copy)."),Y=p(),c=n("h2"),j=n("a"),O=n("span"),$(A.$$.fragment),_s=p(),T=n("span"),ws=q("Installation"),Z=p(),M=n("p"),ks=q("with pip:"),ss=p(),$(x.$$.fragment),es=p(),U=n("p"),gs=q("with conda:"),ts=p(),$(N.$$.fragment),as=p(),u=n("h2"),b=n("a"),D=n("span"),$(z.$$.fragment),ys=p(),F=n("span"),js=q("Load tensors"),ns=p(),$(L.$$.fragment),os=p(),B=n("p"),bs=q("Loading only part of the tensors (interesting when running on multiple GPU)"),rs=p(),$(C.$$.fragment),ls=p(),d=n("h2"),E=n("a"),K=n("span"),$(H.$$.fragment),Es=p(),Q=n("span"),qs=q("Save tensors"),is=p(),$(I.$$.fragment),this.h()},l(s){const t=Ks('[data-svelte="svelte-1phssyn"]',document.head);h=o(t,"META",{name:!0,content:!0}),t.forEach(e),W=f(s),m=o(s,"H1",{class:!0});var fs=l(m);y=o(fs,"A",{id:!0,class:!0,href:!0});var Ps=l(y);R=o(Ps,"SPAN",{});var As=l(R);v(P.$$.fragment,As),As.forEach(e),Ps.forEach(e),ds=f(fs),J=o(fs,"SPAN",{});var xs=l(J);$s=S(xs,"Safetensors"),xs.forEach(e),fs.forEach(e),X=f(s),G=o(s,"P",{});var Ns=l(G);vs=S(Ns,"Safetensors is a new simple format for storing tensors safely (as opposed to pickle) and that is still fast (zero-copy)."),Ns.forEach(e),Y=f(s),c=o(s,"H2",{class:!0});var hs=l(c);j=o(hs,"A",{id:!0,class:!0,href:!0});var zs=l(j);O=o(zs,"SPAN",{});var Ls=l(O);v(A.$$.fragment,Ls),Ls.forEach(e),zs.forEach(e),_s=f(hs),T=o(hs,"SPAN",{});var Cs=l(T);ws=S(Cs,"Installation"),Cs.forEach(e),hs.forEach(e),Z=f(s),M=o(s,"P",{});var Hs=l(M);ks=S(Hs,"with pip:"),Hs.forEach(e),ss=f(s),v(x.$$.fragment,s),es=f(s),U=o(s,"P",{});var Is=l(U);gs=S(Is,"with conda:"),Is.forEach(e),ts=f(s),v(N.$$.fragment,s),as=f(s),u=o(s,"H2",{class:!0});var ms=l(u);b=o(ms,"A",{id:!0,class:!0,href:!0});var Gs=l(b);D=o(Gs,"SPAN",{});var Ms=l(D);v(z.$$.fragment,Ms),Ms.forEach(e),Gs.forEach(e),ys=f(ms),F=o(ms,"SPAN",{});var Us=l(F);js=S(Us,"Load tensors"),Us.forEach(e),ms.forEach(e),ns=f(s),v(L.$$.fragment,s),os=f(s),B=o(s,"P",{});var Bs=l(B);bs=S(Bs,"Loading only part of the tensors (interesting when running on multiple GPU)"),Bs.forEach(e),rs=f(s),v(C.$$.fragment,s),ls=f(s),d=o(s,"H2",{class:!0});var cs=l(d);E=o(cs,"A",{id:!0,class:!0,href:!0});var Rs=l(E);K=o(Rs,"SPAN",{});var Js=l(K);v(H.$$.fragment,Js),Js.forEach(e),Rs.forEach(e),Es=f(cs),Q=o(cs,"SPAN",{});var Os=l(Q);qs=S(Os,"Save tensors"),Os.forEach(e),cs.forEach(e),is=f(s),v(I.$$.fragment,s),this.h()},h(){i(h,"name","hf:doc:metadata"),i(h,"content",JSON.stringify(Xs)),i(y,"id","safetensors"),i(y,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(y,"href","#safetensors"),i(m,"class","relative group"),i(j,"id","installation"),i(j,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(j,"href","#installation"),i(c,"class","relative group"),i(b,"id","load-tensors"),i(b,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(b,"href","#load-tensors"),i(u,"class","relative group"),i(E,"id","save-tensors"),i(E,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),i(E,"href","#save-tensors"),i(d,"class","relative group")},m(s,t){a(document.head,h),r(s,W,t),r(s,m,t),a(m,y),a(y,R),_(P,R,null),a(m,ds),a(m,J),a(J,$s),r(s,X,t),r(s,G,t),a(G,vs),r(s,Y,t),r(s,c,t),a(c,j),a(j,O),_(A,O,null),a(c,_s),a(c,T),a(T,ws),r(s,Z,t),r(s,M,t),a(M,ks),r(s,ss,t),_(x,s,t),r(s,es,t),r(s,U,t),a(U,gs),r(s,ts,t),_(N,s,t),r(s,as,t),r(s,u,t),a(u,b),a(b,D),_(z,D,null),a(u,ys),a(u,F),a(F,js),r(s,ns,t),_(L,s,t),r(s,os,t),r(s,B,t),a(B,bs),r(s,rs,t),_(C,s,t),r(s,ls,t),r(s,d,t),a(d,E),a(E,K),_(H,K,null),a(d,Es),a(d,Q),a(Q,qs),r(s,is,t),_(I,s,t),ps=!0},p:Qs,i(s){ps||(w(P.$$.fragment,s),w(A.$$.fragment,s),w(x.$$.fragment,s),w(N.$$.fragment,s),w(z.$$.fragment,s),w(L.$$.fragment,s),w(C.$$.fragment,s),w(H.$$.fragment,s),w(I.$$.fragment,s),ps=!0)},o(s){k(P.$$.fragment,s),k(A.$$.fragment,s),k(x.$$.fragment,s),k(N.$$.fragment,s),k(z.$$.fragment,s),k(L.$$.fragment,s),k(C.$$.fragment,s),k(H.$$.fragment,s),k(I.$$.fragment,s),ps=!1},d(s){e(h),s&&e(W),s&&e(m),g(P),s&&e(X),s&&e(G),s&&e(Y),s&&e(c),g(A),s&&e(Z),s&&e(M),s&&e(ss),g(x,s),s&&e(es),s&&e(U),s&&e(ts),g(N,s),s&&e(as),s&&e(u),g(z),s&&e(ns),g(L,s),s&&e(os),s&&e(B),s&&e(rs),g(C,s),s&&e(ls),s&&e(d),g(H),s&&e(is),g(I,s)}}}const Xs={local:"safetensors",title:"Safetensors"};function Ys(Ss){return Vs(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class ee extends Ts{constructor(h){super();Ds(this,h,Ys,Ws,Fs,{})}}export{ee as default,Xs as metadata};
